// Copyright 2019 Canonical Ltd.

package main

import (
	"fmt"
	"os"

	"github.com/juju/cmd"
)

// main is the entry point for the command.
func main() {
	os.Exit(runMain())
}

// runMain executes the command, it returns a return code suitable for
// providing to os.Exit.
func runMain() int {
	ctxt, err := cmd.DefaultContext()
	if err != nil {
		fmt.Fprintf(os.Stderr, "%s: initialisation error: %v", cmdName, err)
		return 1
	}
	sc := command()
	return cmd.Main(sc, ctxt, os.Args[1:])
}
