// The code in this file was automatically generated by running httprequest-generate-client.
// DO NOT EDIT

package contractclient

import (
	"context"
	"github.com/CanonicalLtd/ua-contracts/internal/v1"
	"github.com/CanonicalLtd/ua-contracts/params"
	"github.com/CanonicalLtd/ua-contracts/version"
	"gopkg.in/httprequest.v1"
)

type client struct {
	Client httprequest.Client
}

// AddContractMachine associates a machine with a contract and
// returns a machine token that allows the machine to request
// resources available through that contract.
func (c *client) AddContractMachine(ctx context.Context, p *params.AddContractMachineRequest) (*params.AddContractMachineResponse, error) {
	var r *params.AddContractMachineResponse
	err := c.Client.Call(ctx, p, &r)
	return r, err
}

// AddProduct adds a product.
func (c *client) AddProduct(ctx context.Context, p *params.AddProductRequest) error {
	return c.Client.Call(ctx, p, nil)
}

// ConfigureContract sets per-contract resource configuration data.
func (c *client) ConfigureContract(ctx context.Context, p *params.ConfigureContractRequest) error {
	return c.Client.Call(ctx, p, nil)
}

// GetAccountContracts gets the available contracts for the requested account.
func (c *client) GetAccountContracts(ctx context.Context, p *params.GetAccountContractsRequest) (*params.GetContractsResponse, error) {
	var r *params.GetContractsResponse
	err := c.Client.Call(ctx, p, &r)
	return r, err
}

// GetAccounts gets the available accounts for the logged in user.
func (c *client) GetAccounts(ctx context.Context, p *params.GetAccountsRequest) (*params.GetAccountsResponse, error) {
	var r *params.GetAccountsResponse
	err := c.Client.Call(ctx, p, &r)
	return r, err
}

// GetCanonicalSSOMacaroon returns a newly minted macaroon with a
// third-party caveat address to canonical SSO. Once discharged this
// caveat can be used to authenticate requests.
func (c *client) GetCanonicalSSOMacaroon(ctx context.Context, p *params.GetCanonicalSSOMacaroonRequest) (*params.GetCanonicalSSOMacaroonResponse, error) {
	var r *params.GetCanonicalSSOMacaroonResponse
	err := c.Client.Call(ctx, p, &r)
	return r, err
}

// GetContract gets information on a contract.
func (c *client) GetContract(ctx context.Context, p *params.GetContractRequest) (*params.AccountContractInfo, error) {
	var r *params.AccountContractInfo
	err := c.Client.Call(ctx, p, &r)
	return r, err
}

// GetContractConfig returns per-contract resource configuration data.
func (c *client) GetContractConfig(ctx context.Context, p *params.GetContractConfigRequest) (*params.GetContractConfigResponse, error) {
	var r *params.GetContractConfigResponse
	err := c.Client.Call(ctx, p, &r)
	return r, err
}

// GetContractMachine retrieves the information about a machine under a
// contract.
func (c *client) GetContractMachine(ctx context.Context, p *params.GetContractMachineRequest) (*params.AddContractMachineResponse, error) {
	var r *params.AddContractMachineResponse
	err := c.Client.Call(ctx, p, &r)
	return r, err
}

// GetContractToken creates a contract token and returns it. If a
// contract token exists for the contract then return that.
// TODO(mhilton) we should probably have a way to force the creation of a
// new token.
func (c *client) GetContractToken(ctx context.Context, p *params.GetContractTokenRequest) (*params.GetContractTokenResponse, error) {
	var r *params.GetContractTokenResponse
	err := c.Client.Call(ctx, p, &r)
	return r, err
}

// GetContractTokenForAWSInstance creates, or retrieves, an appropriate
// account and contract for the specified aws instance, returning a
// contract token that can then be used to attach the machine.
func (c *client) GetContractTokenForAWSInstance(ctx context.Context, p *params.GetContractTokenForAWSInstanceRequest) (*params.GetContractTokenResponse, error) {
	var r *params.GetContractTokenResponse
	err := c.Client.Call(ctx, p, &r)
	return r, err
}

// GetProduct returns information on one product.
func (c *client) GetProduct(ctx context.Context, p *params.GetProductRequest) (*params.Product, error) {
	var r *params.Product
	err := c.Client.Call(ctx, p, &r)
	return r, err
}

// GetProducts gets information on all available products.
func (c *client) GetProducts(ctx context.Context, p *params.GetProductsRequest) (*params.GetProductsResponse, error) {
	var r *params.GetProductsResponse
	err := c.Client.Call(ctx, p, &r)
	return r, err
}

// GetResourceMachineAccess returns information on a specific resource
// for a machine, including a resource token that acts as an authorization
// token when accessing the resource-specific service.
func (c *client) GetResourceMachineAccess(ctx context.Context, p *params.GetResourceMachineAccessRequest) (*params.GetResourceMachineAccessResponse, error) {
	var r *params.GetResourceMachineAccessResponse
	err := c.Client.Call(ctx, p, &r)
	return r, err
}

// GetResourceTokenInfo returns information on a specific resource for a machine.
// This end point is called by a resource server.
func (c *client) GetResourceTokenInfo(ctx context.Context, p *params.GetResourceTokenInfoRequest) (*params.GetResourceTokenInfoResponse, error) {
	var r *params.GetResourceTokenInfoResponse
	err := c.Client.Call(ctx, p, &r)
	return r, err
}

// RevokeContractMachine revokes a machine from a contract. Subsequent
// requests to access resources associated with the contract will fail
// until the machine is re-attached to the contract.
func (c *client) RevokeContractMachine(ctx context.Context, p *params.RevokeContractMachineRequest) (*params.MachineTokenInfo, error) {
	var r *params.MachineTokenInfo
	err := c.Client.Call(ctx, p, &r)
	return r, err
}

// GET /debug/info
func (c *client) ServeDebugInfo(ctx context.Context, p *v1.DebugInfoRequest) (version.Version, error) {
	var r version.Version
	err := c.Client.Call(ctx, p, &r)
	return r, err
}

// SetServiceAccountPassword sets the password for a service account.
func (c *client) SetServiceAccountPassword(ctx context.Context, p *params.SetServiceAccountPasswordRequest) error {
	return c.Client.Call(ctx, p, nil)
}

// UpdateAccountContracts updates account's contracts by synching its state with Salesforce.
func (c *client) UpdateAccountContracts(ctx context.Context, p *params.UpdateAccountContractsRequest) (*params.GetContractsResponse, error) {
	var r *params.GetContractsResponse
	err := c.Client.Call(ctx, p, &r)
	return r, err
}
