# UA Service

This project contains v1 of the contract service, which supports the UA client.

The contract service spec is OpenAPI 3.0, see [`contracts.yaml`](contracts.yaml).

Refer to the spec, [_"Authentication workflows for new UA services"_](https://docs.google.com/document/d/1C1u-5Hcf5rr0KWO680qPXm_rm87NWSFjlNFfvtE5oEs/edit#) as context
for how this API is intended to be consumed. The security on each endpoint also hints at who the intended caller is.

A custom security scheme has been added for Candid-based auth. Note that the UA
client does not need to deal with macaroons, this method is primarily intended
for agents and contract service administrative operations.

TODO: flows supporting direct Ubuntu SSO authentication of users with interactive CLI user agents, web apps, etc.

# Code/docs generation

To generate code or documentation from the contract service spec:

## 1. Install openapi-generator

Follow the instructions given here: https://github.com/OpenAPITools/openapi-generator#launcher-script

Put the `openapi-generator-cli` script somewhere in your path.

You will need to have openjdk and mvn installed in order for the launcher script to work.

I recommend the following to get these set up, feel free and try something else but YMMV there:

- `apt install openjdk-11-jdk-headless`
- Download and install the latest Apache Maven from here: https://maven.apache.org/download.cgi
  Untar/unzip where you like and add the `bin` directory to your path.

The above has been tested on 18.04.

## 2. Generate code and docs

There are several scripts provided to generate code from the OpenAPI spec:

`./scripts/generate-go-server.bash` generates a skeleton Go server based on net/http and gorilla mux.

`./scripts/generate-python-server.bash` generates a Python Flask-based server (which I have not tested).

`./scripts/generate-docs.bash` generates an index.html documenting the API.

