// Copyright 2019 Canonical Ltd.

package kafkaauditor_test

import (
	"testing"

	"github.com/Shopify/sarama"
	qt "github.com/frankban/quicktest"

	"github.com/CanonicalLtd/ua-contracts/internal/kafkaauditor"
)

func TestConfig(t *testing.T) {
	c := qt.New(t)

	cfg := kafkaauditor.Config{
		Brokers:         []string{"127.0.0.1:9092"},
		VersionOverride: "0.10.1.0",
	}
	c.Assert(cfg.Validate(), qt.Equals, nil)
	c.Assert(cfg.Version, qt.Equals, sarama.V0_10_1_0)

	cfg.VersionOverride = ""
	c.Assert(cfg.Validate(), qt.Equals, nil)
	ver, err := sarama.ParseKafkaVersion("2.1.0")
	c.Assert(err, qt.Equals, nil)
	c.Assert(cfg.Version, qt.Equals, ver)
}
