// Copyright 2019 Canonical Ltd.

package storeutil_test

import (
	"context"
	"testing"

	qt "github.com/frankban/quicktest"

	"github.com/CanonicalLtd/ua-contracts/internal/memstore"
	"github.com/CanonicalLtd/ua-contracts/internal/saauth"
	"github.com/CanonicalLtd/ua-contracts/internal/storeutil"
)

func TestEnsureAdminServiceAccount(t *testing.T) {
	c := qt.New(t)

	ctx := context.Background()
	s := memstore.New()

	err := storeutil.EnsureAdminServiceAccount(ctx, s, "password1")
	c.Assert(err, qt.Equals, nil)
	id, err := saauth.Validate(ctx, s, "admin", "password1")
	c.Assert(err, qt.Equals, nil)
	ok, err := id.Allow(ctx, []string{"admin"})
	c.Assert(err, qt.Equals, nil)
	c.Assert(ok, qt.Equals, true)

	err = storeutil.EnsureAdminServiceAccount(ctx, s, "password2")
	c.Assert(err, qt.Equals, nil)
	id, err = saauth.Validate(ctx, s, "admin", "password1")
	c.Assert(err, qt.Equals, nil)
	ok, err = id.Allow(ctx, []string{"admin"})
	c.Assert(err, qt.Equals, nil)
	c.Assert(ok, qt.Equals, true)
}
