// Copyright 2019 Canonical Ltd.

package storeutil_test

import (
	"testing"

	qt "github.com/frankban/quicktest"

	"github.com/CanonicalLtd/ua-contracts/internal/memstore"
	"github.com/CanonicalLtd/ua-contracts/internal/storeutil"
)

func TestEnsureDefaultProducts(t *testing.T) {
	c := qt.New(t)

	ctx := testContext(c)
	st := memstore.New()
	expectProducts := []string{
		"free",
		"esm",
		"livepatch",
		"fips",
		"support-essential",
		"support-standard",
		"support-advanced",
	}
	for i := 0; i < 2; i++ {
		err := storeutil.EnsureDefaultProducts(ctx, st)
		c.Assert(err, qt.Equals, nil)
		for _, id := range expectProducts {
			p, err := st.Product(ctx, id)
			c.Assert(err, qt.Equals, nil, qt.Commentf("product %s", id))
			c.Assert(p.ID, qt.Equals, id)
			if len(p.Resources) == 0 {
				c.Errorf("product %s has no resources", id)
			}
		}
	}
}
