package params

import (
	"time"

	httprequest "gopkg.in/httprequest.v1"
)

// AuditLogEntry is an individual audit log entry from the audit table.
type AuditLogEntry struct {
	// The parameters that were passed in the event
	Data string `json:"data"`
	Id   string `json:"id"`
	// The timestamp that the event occured
	Time time.Time `json:"time"`
	// The type of audit entry
	Type string `json:"type"`
}

// AuditLogQueryResult is the result from an audit log query
type AuditLogQueryResult struct {
	Results []AuditLogEntry `json:"results"`
}

// AuditLogQueryRequest holds the request value for a AuditLogQuery call.
type AuditLogQueryRequest struct {
	httprequest.Route `httprequest:"GET /v1/audit"`
	Start             time.Time `httprequest:"start,form"`
	End               time.Time `httprequest:"end,form"`
	Type              string    `httprequest:"type,form"`
}
