// Copyright 2019 Canonical Ltd.

package kafkaauditor

import (
	"context"
	"time"

	"github.com/CanonicalLtd/ua-contracts/internal/store"
)

var (
	NewClient      = newClient
	MessageSkipped = &messageSkipped
)

func New(store store.Store, a Auditor) *auditStore {
	return &auditStore{
		store:   store,
		auditor: a,
	}
}

func SetAuditor(st *auditStore, auditor Auditor) {
	st.setAuditor(auditor)
}

func (c *Config) NewStore(ctx context.Context, store store.Store, auditorFactory func() (Auditor, error), backoffDuration time.Duration) (AuditStore, error) {
	return c.store(ctx, store, auditorFactory, backoffDuration)
}
