package v1

import (
	"gopkg.in/httprequest.v1"

	"github.com/CanonicalLtd/ua-contracts/version"
)

// DebugInfoRequest documents the /debug/info endpoint. As
// it contains no request information there is no need to ever create
// one.
type DebugInfoRequest struct {
	httprequest.Route `httprequest:"GET /debug/info"`
}

// GET /debug/info
func (*handler) ServeDebugInfo(*DebugInfoRequest) (version.Version, error) {
	return version.VersionInfo, nil
}
