package v1_test

import (
	"testing"

	qt "github.com/frankban/quicktest"
	"gopkg.in/httprequest.v1"

	"github.com/CanonicalLtd/ua-contracts/internal/memstore"
	v1 "github.com/CanonicalLtd/ua-contracts/internal/v1"
	"github.com/CanonicalLtd/ua-contracts/version"
)

func TestServeDebugInfo(t *testing.T) {
	c := qt.New(t)
	defer c.Done()

	ctx := testContext(c)
	srvStore := memstore.New()
	u := newServer(ctx, c, v1.Params{Store: srvStore})

	client := &httprequest.Client{
		BaseURL: u,
	}
	var response version.Version
	err := client.Call(ctx, &v1.DebugInfoRequest{}, &response)
	c.Assert(err, qt.Equals, nil)
}
