// Code generated by openapi-httprequest. DO NOT EDIT.

package params

import (
	"time"

	httprequest "gopkg.in/httprequest.v1"
)

type APIHandler interface {
	AddAccount(httprequest.Params, *AddAccountRequest) (*AccountInfo, error)

	AddAccountContract(httprequest.Params, *AddAccountContractRequest) (*AccountContractInfo, error)

	AddContractMachine(httprequest.Params, *AddContractMachineRequest) (*AddContractMachineResponse, error)

	AddProduct(httprequest.Params, *AddProductRequest) error

	ConfigureContract(httprequest.Params, *ConfigureContractRequest) error

	GetAccountContracts(httprequest.Params, *GetAccountContractsRequest) (*GetContractsResponse, error)

	GetAccounts(httprequest.Params, *GetAccountsRequest) (*GetAccountsResponse, error)

	GetCanonicalSSOMacaroon(httprequest.Params, *GetCanonicalSSOMacaroonRequest) (*GetCanonicalSSOMacaroonResponse, error)

	GetContract(httprequest.Params, *GetContractRequest) (*AccountContractInfo, error)

	GetContractConfig(httprequest.Params, *GetContractConfigRequest) (*GetContractConfigResponse, error)

	GetContractMachine(httprequest.Params, *GetContractMachineRequest) (*AddContractMachineResponse, error)

	GetContractToken(httprequest.Params, *GetContractTokenRequest) (*GetContractTokenResponse, error)

	GetContractTokenForAWSInstance(httprequest.Params, *GetContractTokenForAWSInstanceRequest) (*GetContractTokenResponse, error)

	GetContractTokenForAzureInstance(httprequest.Params, *GetContractTokenForAzureInstanceRequest) (*GetContractTokenResponse, error)

	GetProduct(httprequest.Params, *GetProductRequest) (*Product, error)

	GetProducts(httprequest.Params, *GetProductsRequest) (*GetProductsResponse, error)

	GetResourceMachineAccess(httprequest.Params, *GetResourceMachineAccessRequest) (*GetResourceMachineAccessResponse, error)

	GetResourceTokenInfo(httprequest.Params, *GetResourceTokenInfoRequest) (*GetResourceTokenInfoResponse, error)

	RevokeContractMachine(httprequest.Params, *RevokeContractMachineRequest) (*MachineTokenInfo, error)

	SetServiceAccountPassword(httprequest.Params, *SetServiceAccountPasswordRequest) error

	UpdateAccountContracts(httprequest.Params, *UpdateAccountContractsRequest) (*GetContractsResponse, error)

	UpdateProduct(httprequest.Params, *UpdateProductRequest) error
}

type AccountContractInfo struct {
	AccountInfo  AccountInfo  `json:"accountInfo"`
	ContractInfo ContractInfo `json:"contractInfo"`
}

type AccountInfo struct {
	CreatedAt time.Time `json:"createdAt"`
	Id        string    `json:"id"`
	Name      string    `json:"name"`
}

type AddContractMachineBody struct {
	// Machine architecture; `uname -i`
	Architecture string `json:"architecture"`
	// Obfuscated machine ID, see MachineTokenInfo.machine-id for details.
	MachineId string `json:"machineId"`
	Os        OS     `json:"os"`
}

type AddContractMachineResponse struct {
	// New machine token secret
	MachineToken     string           `json:"machineToken"`
	MachineTokenInfo MachineTokenInfo `json:"machineTokenInfo"`
}

type AffordancesAptRepository struct {
	// Platform architectures for which packages may be provided, such as "x86_64", "ppc64le", "s390x".
	Architectures []string `json:"architectures"`
	// Distribution series for which packages may be provided, such as "trusty", "xenial", "bionic".
	Series []string `json:"series,omitempty"`
}

type AffordancesLivepatch struct {
	// Platform architectures for which patches may be provided, such as "x86_64", "ppc64le", "s390x".
	Architectures []string `json:"architectures"`
	// Kernel flavors for which patches may be provided, such as "generic", "aws", "ibm".
	KernelFlavors []string `json:"kernelFlavors"`
	// The minimum kernel version required to install livepatch client snap, like "4.4".
	MinKernelVersion string `json:"minKernelVersion"`
	// Distribution series for which patches may be provided, such as "trusty", "xenial", "bionic".
	Series []string `json:"series,omitempty"`
	// Indicate which tier to access (updates is the paid version and standard is the free version)
	Tier string `json:"tier"`
}

type AffordancesSupport struct {
	// Support level provided, such as "community", "essential", "standard", "advanced"
	SupportLevel string `json:"supportLevel"`
}

type AzureComputeInstanceMetadata struct {
	// Azure Environment where the VM is running in
	AzEnvironment string `json:"azEnvironment,omitempty"`
	// Azure Region the VM is running in
	Location string `json:"location,omitempty"`
	// Name of the VM
	Name string `json:"name,omitempty"`
	// Offer information for the VM image. This value is only present for images deployed from Azure image gallery.
	Offer string `json:"offer,omitempty"`
	// Linux or Windows
	OsType string `json:"osType,omitempty"`
	// Placement Group of your virtual machine scale set
	PlacementGroupId string `json:"placementGroupId,omitempty"`
	// Fault domain the VM is running in
	PlatformFaultDomain string `json:"platformFaultDomain,omitempty"`
	// Update domain the VM is running in
	PlatformUpdateDomain string `json:"platformUpdateDomain,omitempty"`
	// Provider of the VM
	Provider string `json:"provider,omitempty"`
	// Publisher of the VM image
	Publisher string `json:"publisher,omitempty"`
	// Resource group for your Virtual Machine
	ResourceGroupName string `json:"resourceGroupName,omitempty"`
	// Specific SKU for the VM image
	Sku string `json:"sku,omitempty"`
	// Azure subscription for the Virtual Machine
	SubscriptionId string `json:"subscriptionId,omitempty"`
	// Tags for your Virtual Machine
	Tags string `json:"tags,omitempty"`
	// Version of the VM image
	Version string `json:"version,omitempty"`
	// Unique identifier for the VM
	VmId string `json:"vmId,omitempty"`
	// Virtual Machine ScaleSet Name of your virtual machine scale set
	VmScaleSetName string `json:"vmScaleSetName,omitempty"`
	// VM size
	VmSize string `json:"vmSize,omitempty"`
	// Availability Zone of your virtual machine
	Zone string `json:"zone,omitempty"`
}

type ConfigureContractBody struct {
	// Per-contract resource configuration.
	Resources []ProductResource `json:"resources"`
}

type ContractInfo struct {
	CreatedAt time.Time `json:"createdAt"`
	// Account admin user who created ("entered into", "signed") the contract.
	CreatedBy     string     `json:"createdBy"`
	EffectiveFrom *time.Time `json:"effectiveFrom,omitempty"`
	EffectiveTo   *time.Time `json:"effectiveTo,omitempty"`
	Id            string     `json:"id"`
	Name          string     `json:"name"`
	// The system that generated the contract.
	Origin               string        `json:"origin,omitempty"`
	ResourceEntitlements []Entitlement `json:"resourceEntitlements"`
}

// Information about a contract token.
// TODO: capabilities, etc.
type ContractTokenInfo struct {
	ContractInfo ContractInfo `json:"contractInfo"`
	Expires      *time.Time   `json:"expires,omitempty"`
}

// Directives for apt-repository resources such as ESM and FIPS.
type DirectivesAptRepository struct {
	// List of packages that should be installed when enabling the entitlement.
	AdditionalPackages []string `json:"additionalPackages"`
	// Apt repository signing GPG key. This can be either a public key
	// fingerprint, or an ascii-armored public key. Required.
	AptKey string `json:"aptKey"`
	// Apt repository base URL. Required.
	AptURL string `json:"aptURL"`
	// List of apt suites exposed by the mirror, like "precise" or "trusty-security".
	Suites []string `json:"suites"`
}

// Resource directives for Livepatch.
type DirectivesLivepatch struct {
	// CA certificate chain of the Livepatch server in PEM format.
	// Specified for on-prem Livepatch servers secured by a self-signed or internal CA
	// certificate that is not in the core snap CA roots.
	CaCerts string `json:"caCerts"`
	// URL of the Livepatch server. This field is required.
	RemoteServer string `json:"remoteServer"`
}

// An entitlement describes whether resources are entitled by a contract
// contract, and if so, answers the questions:
// - What can a consumer of the resource (typically a machine) do with
//   them? (Affordances)
// - What binding terms apply to their use? (Obligations)
// - What must be done by a consumer in order to access them? (Directives)
//
// _Affordances_ determine how a resource may be used within a contract.
//
// On a machine, an affordance serves to explain why particular aspects of
// a resource may or may not be available. Where the resource
//
// On the service that provides said resource under a contract,
// affordances can be used to determine what access should be allowed.
//
// For example, a contract provides an affordance for Livepatch which
// enumerates the kernel flavors eligible to receive patches. The UA
// machine client does not necessarily use the affordance to configure Livepatch;
// but it serves to explain to that client why or why not Livepatch is available
// on the current running system. On the Livepatch server, the affordance
// can be used to gate whether patches may be provided to a particular machine.
//
// _Directives_ consist of resource(service)-specific configuration that
// is necessary in order for the resource to be used in a given context, but are
// otherwise not part of the business rules defined by a contract.
//
// For example, a customer's machines need to access a dedicated Livepatch
// server and ESM archives, with custom URLs and root CA certificate. Directives
// are used to provide this information to the machine, so that it can contact the
// resource.
type Entitlement interface{}

// EntitlementAptRepository holds entitlement information for resources
// types that talk to an Apt repository.
type EntitlementAptRepository struct {
	Affordances AffordancesAptRepository `json:"affordances"`
	Directives  DirectivesAptRepository  `json:"directives"`
	// Indicate whether resource access is entitled under the contract.
	Entitled    bool        `json:"entitled"`
	Obligations Obligations `json:"obligations"`
	// Series specific overrides.
	Series interface{} `json:"series,omitempty"`
	Type   string      `json:"type"`
}

// EntitlementBase holds the fields that all entitlement types have in common.
type EntitlementBase struct {
	// Indicate whether resource access is entitled under the contract.
	Entitled bool   `json:"entitled"`
	Type     string `json:"type"`
}

// EntitlementLivepatch holds entitlement information for resources
// types that talk to an livepatch server.
type EntitlementLivepatch struct {
	Affordances AffordancesLivepatch `json:"affordances"`
	Directives  DirectivesLivepatch  `json:"directives"`
	// Indicate whether resource access is entitled under the contract.
	Entitled    bool        `json:"entitled"`
	Obligations Obligations `json:"obligations"`
	// Series specific overrides.
	Series interface{} `json:"series,omitempty"`
	Type   string      `json:"type"`
}

// EntitlementSupport holds entitlement information for resources
// types that entail support.
type EntitlementSupport struct {
	Affordances AffordancesSupport `json:"affordances"`
	// Indicate whether resource access is entitled under the contract.
	Entitled    bool        `json:"entitled"`
	Obligations Obligations `json:"obligations"`
	Type        string      `json:"type"`
}

type Error struct {
	Code ErrorCode `json:"code,omitempty"`
	// Short message describing why the request could not be processed.
	Message string `json:"message"`
	// Correlation ID for log tracing purposes (OpenZipKin for example) if available.
	TraceId string `json:"traceId,omitempty"`
}

// A code representing the kind of error.
// TODO enumerate all the possible error codes here?
type ErrorCode string

// List of user accounts.
type GetAccountsResponse struct {
	Accounts []AccountInfo `json:"accounts"`
}

// A macaroon with a third-party caveat addressed to Ubuntu SSO.
type GetCanonicalSSOMacaroonResponse struct {
	// Macaroon value encoded using version 1 binary format and URL safe base64 without any padding characters.
	Macaroon string `json:"macaroon"`
}

type GetContractConfigResponse struct {
	Resources []ProductResource `json:"resources"`
}

type GetContractTokenResponse struct {
	ContractToken     string            `json:"contractToken"`
	ContractTokenInfo ContractTokenInfo `json:"contractTokenInfo"`
}

// List of contracts.
type GetContractsResponse struct {
	Contracts []AccountContractInfo `json:"contracts"`
}

// List of products
type GetProductsResponse struct {
	Products []Product `json:"products"`
}

type GetResourceMachineAccessResponse struct {
	Entitlement Entitlement `json:"entitlement"`
	// token for use to access the resource
	ResourceToken string `json:"resourceToken,omitempty"`
}

type GetResourceTokenInfoResponse struct {
	// affordances that apply to the resource, only present if resource access is granted
	Affordances interface{} `json:"affordances,omitempty"`
	// see MachineTokenInfo.contract-id for details.
	ContractId string `json:"contractId"`
	Error      *Error `json:"error,omitempty"`
	// see MachineTokenInfo.machine-id for details.
	MachineId string `json:"machineId"`
}

type MachineTokenInfo struct {
	AccountInfo  AccountInfo  `json:"accountInfo"`
	ContractInfo ContractInfo `json:"contractInfo"`
	Expires      *time.Time   `json:"expires,omitempty"`
	// Obfuscated machine ID, derived from local systemd /etc/machine-id.
	// See https://www.freedesktop.org/software/systemd/man/machine-id.html#
	// for more information on how this should be generated by the client.
	MachineId string `json:"machineId"`
}

type OS struct {
	// OS distribution name; `lsb_release -d`
	Distribution string `json:"distribution"`
	// Full kernel version including patch version and flavor; for example, "4.15.0-39.42-generic"
	Kernel string `json:"kernel"`
	// OS release name; `lsb_release -r`
	Release string `json:"release"`
	// Distribution series or code name; `lsb_release -c`
	Series string `json:"series"`
	// OS type; for example, "Linux", "Windows", "OpenBSD"
	Type string `json:"type"`
}

// _Obligations_ are policies that are contractually required to be
// implemented. It may need to be implemented by the context (machine) or resource (service).
// It may be checked for compliance by an auditing system or process.
//
// For example, a machine may be obligated to enable a resource by default
// if it is available, when that machine is associated with the contract.
type Obligations struct {
	EnableByDefault bool `json:"enableByDefault"`
}

type Product struct {
	// Product ID
	Id string `json:"id"`
	// Product Name
	Name string `json:"name"`
	// Resources enabled by this product.
	Resources []ProductResource `json:"resources"`
}

type ProductResource struct {
	// Whether this resource can be overridden in a contract
	// using this product.
	CanOverride bool `json:"canOverride"`
	// JSON parameters for product template
	Data interface{} `json:"data"`
	// Type of resource enabled by this product
	ResourceType string `json:"resourceType"`
}

// Body of the SetServiceAccountPassword request.
type SetServiceAccountPasswordBody struct {
	// Password to set for the service-account.
	Password string `json:"password"`
}

// AddAccountContractRequest holds the request value for a AddAccountContract call.
// Record that an account has entered into a contract.
type AddAccountContractRequest struct {
	httprequest.Route `httprequest:"POST /v1/accounts/:account/contracts"`
	Account           string                        `httprequest:"account,path"`
	Body              AddAccountContractRequestBody `httprequest:",body"`
}

type AddAccountContractRequestBody struct {
	// Contract creator.
	CreatedBy string `json:"createdBy"`
	// Time the contract starts.
	EffectiveFrom *time.Time `json:"effectiveFrom,omitempty"`
	// Time the contract finishes.
	EffectiveTo *time.Time `json:"effectiveTo,omitempty"`
	// Contract name.
	Name string `json:"name"`
	// Product IDs to which the contract is subscribed.
	Products []string `json:"products"`
}

// AddAccountRequest holds the request value for a AddAccount call.
// Add an account. Accounts may be added by an admin or an SF mediator agent.
type AddAccountRequest struct {
	httprequest.Route `httprequest:"POST /v1/accounts"`
	Body              AddAccountRequestBody `httprequest:",body"`
}

type AddAccountRequestBody struct {
	// Account name
	Name string `json:"name,omitempty"`
}

// AddContractMachineRequest holds the request value for a AddContractMachine call.
// Authorize a machine under a contract and return a token
// that allows the machine access.
//
// Note: Contexts are _where_ resources are used under a contract. Since v1 of this
// service is specifically targeting UA contracts, supported contexts are always
// "machines". v2 of this API will expose this as /contract/{contract}/context
type AddContractMachineRequest struct {
	httprequest.Route `httprequest:"POST /v1/context/machines/token"`
	Body              AddContractMachineBody `httprequest:",body"`
}

// AddProductRequest holds the request value for a AddProduct call.
// Create a product.
type AddProductRequest struct {
	httprequest.Route `httprequest:"POST /v1/products"`
	Body              Product `httprequest:",body"`
}

// ConfigureContractRequest holds the request value for a ConfigureContract call.
// Configure resource information for a specific contract,
// for example to add on-prem server URLs.
type ConfigureContractRequest struct {
	httprequest.Route `httprequest:"PUT /v1/contracts/:contract/config"`
	Contract          string                `httprequest:"contract,path"`
	Body              ConfigureContractBody `httprequest:",body"`
}

// GetAccountContractsRequest holds the request value for a GetAccountContracts call.
// Find contracts that an account is party to.
type GetAccountContractsRequest struct {
	httprequest.Route `httprequest:"GET /v1/accounts/:account/contracts"`
	Account           string `httprequest:"account,path"`
}

// GetAccountsRequest holds the request value for a GetAccounts call.
// Find accounts. Admins can search across all accounts. Users can see only those accounts they have access to.
type GetAccountsRequest struct {
	httprequest.Route `httprequest:"GET /v1/accounts"`
	Email             string `httprequest:"email,form"`
}

// GetCanonicalSSOMacaroonRequest holds the request value for a GetCanonicalSSOMacaroon call.
// Get an authentication macaroon with a third-party caveat addressed
// to SSO. The discharged macaroon can be used as an authentication
// token for endpoints on this service.
type GetCanonicalSSOMacaroonRequest struct {
	httprequest.Route `httprequest:"GET /v1/canonical-sso-macaroon"`
}

// GetContractConfigRequest holds the request value for a GetContractConfig call.
// Get contract-specific resource configuration.
type GetContractConfigRequest struct {
	httprequest.Route `httprequest:"GET /v1/contracts/:contract/config"`
	Contract          string `httprequest:"contract,path"`
}

// GetContractMachineRequest holds the request value for a GetContractMachine call.
// Retrieve the entitlement information for a machine attached to
// a contract.
type GetContractMachineRequest struct {
	httprequest.Route `httprequest:"GET /v1/contracts/:contract/context/machines/:machine"`
	Contract          string `httprequest:"contract,path"`
	Machine           string `httprequest:"machine,path"`
}

// GetContractRequest holds the request value for a GetContract call.
// Find a contract by ID.
type GetContractRequest struct {
	httprequest.Route `httprequest:"GET /v1/contracts/:contract"`
	Contract          string `httprequest:"contract,path"`
}

// GetContractTokenForAWSInstanceRequest holds the request value for a GetContractTokenForAWSInstance call.
// Get an appropriate contract token for the provided AWS machine instance.
type GetContractTokenForAWSInstanceRequest struct {
	httprequest.Route `httprequest:"POST /v1/clouds/aws/token"`
	Body              GetContractTokenForAWSInstanceRequestBody `httprequest:",body"`
}

type GetContractTokenForAWSInstanceRequestBody struct {
	// AWS Instance Identity document PKCS#7 signature, see
	// https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-identity-documents.html.
	Pkcs7 string `json:"pkcs7"`
}

// GetContractTokenForAzureInstanceRequest holds the request value for a GetContractTokenForAzureInstance call.
// Get an appropriate contract token for the provided Azure machine instance.
type GetContractTokenForAzureInstanceRequest struct {
	httprequest.Route `httprequest:"POST /v1/clouds/azure/token"`
	Body              GetContractTokenForAzureInstanceRequestBody `httprequest:",body"`
}

type GetContractTokenForAzureInstanceRequestBody struct {
	Compute *AzureComputeInstanceMetadata `json:"compute,omitempty"`
	// Azure Attested Instance Metadata document PKCS#7 signature, see
	// https://docs.microsoft.com/en-us/azure/virtual-machines/windows/instance-metadata-service#attested-data.
	Pkcs7 string `json:"pkcs7"`
}

// GetContractTokenRequest holds the request value for a GetContractToken call.
// Create a contract token that can be used to
// create machine tokens that can be used to
// access resources.
// Note: this is a placeholder for a later endpoint
// that will associate contracts with users.
//
// TODO declare optional name, capability limits
// such as: contract ID, context type (machines), lifetime, etc.
type GetContractTokenRequest struct {
	httprequest.Route `httprequest:"POST /v1/contracts/:contract/token"`
	Contract          string                      `httprequest:"contract,path"`
	Body              GetContractTokenRequestBody `httprequest:",body"`
}

type GetContractTokenRequestBody interface{}

// GetProductRequest holds the request value for a GetProduct call.
// Get information on a product.
type GetProductRequest struct {
	httprequest.Route `httprequest:"GET /v1/products/:productID"`
	ProductID         string `httprequest:"productID,path"`
}

// GetProductsRequest holds the request value for a GetProducts call.
// Get details of all products.
type GetProductsRequest struct {
	httprequest.Route `httprequest:"GET /v1/products"`
}

// GetResourceMachineAccessRequest holds the request value for a GetResourceMachineAccess call.
// Get affordances and obligations that apply to the resource for the machine token provided.
// Affordances are domain-specific to the service that provides the resource, and determined
// by the contract.
type GetResourceMachineAccessRequest struct {
	httprequest.Route `httprequest:"GET /v1/resources/:resource/context/machines/:machine"`
	Resource          string `httprequest:"resource,path"`
	Machine           string `httprequest:"machine,path"`
}

// GetResourceTokenInfoRequest holds the request value for a GetResourceTokenInfo call.
// Get affordances, machine and contract ids that apply to the resource for the resource token provided.
// Affordances are domain-specific to the service that provides the resource, and determined
// by the contract.
type GetResourceTokenInfoRequest struct {
	httprequest.Route `httprequest:"GET /v1/resources/:resource"`
	Resource          string `httprequest:"resource,path"`
	Token             string `httprequest:"token,form"`
}

// RevokeContractMachineRequest holds the request value for a RevokeContractMachine call.
// Remove machine from a contract. Once revoked, any machine tokens
// pertaining to the contract will fail to work until the machine
// and contract are reattached.
type RevokeContractMachineRequest struct {
	httprequest.Route `httprequest:"DELETE /v1/contracts/:contract/context/machines/:machine"`
	Contract          string `httprequest:"contract,path"`
	Machine           string `httprequest:"machine,path"`
}

// SetServiceAccountPasswordRequest holds the request value for a SetServiceAccountPassword call.
// Set the password for a service account, creating the account if necessary.
type SetServiceAccountPasswordRequest struct {
	httprequest.Route `httprequest:"POST /v1/service-accounts/:account"`
	Account           string                        `httprequest:"account,path"`
	Body              SetServiceAccountPasswordBody `httprequest:",body"`
}

// UpdateAccountContractsRequest holds the request value for a UpdateAccountContracts call.
// Synchronize account or user data from salesforce.
type UpdateAccountContractsRequest struct {
	httprequest.Route `httprequest:"POST /v1/salesforce/sync"`
	Body              UpdateAccountContractsRequestBody `httprequest:",body"`
}

type UpdateAccountContractsRequestBody struct {
	// Email address
	Mail string `json:"mail,omitempty"`
	// Salesforce account id.
	Sfid string `json:"sfid,omitempty"`
}

// UpdateProductRequest holds the request value for a UpdateProduct call.
// Update a product.
type UpdateProductRequest struct {
	httprequest.Route `httprequest:"PUT /v1/products/:productID"`
	ProductID         string  `httprequest:"productID,path"`
	Body              Product `httprequest:",body"`
}
