#!/bin/sh
# wait-for-postgres.sh
# This script waits for the postgres database when running the service in a development docker-compose environment.
# It is not intended for use beyond this.
# See https://docs.docker.com/compose/startup-order/

set -e

cmd="$@"

until pg_isready; do
  >&2 echo "Postgres is unavailable - sleeping"
  sleep 1
done

>&2 echo "Postgres is up - executing command"
exec $cmd
